import 'package:json_annotation/json_annotation.dart';

part 'codenames_board_base.g.dart';

@JsonSerializable()
class Board {
  List<List<dynamic>> board;

  Board.blank(int w, int h)
      : board = List.generate(h, (_) => List.filled(w, null));

  Board();

  factory Board.fromJson(Map<String, dynamic> json) => _$BoardFromJson(json);

  Map<String, dynamic> toJson() => _$BoardToJson(this);
}

@JsonSerializable()
class GameRequest {
  String type;

  Map<String, dynamic> data;

  GameRequest.fromData(this.type, this.data);

  GameRequest();

  factory GameRequest.fromJson(Map<String, dynamic> json) =>
      _$GameRequestFromJson(json);

  Map<String, dynamic> toJson() => _$GameRequestToJson(this);
}

/**
 * type: GET_BOARD, data: {}
 * type: PICK, data: {point: [x, y]}    
 * type: SWITCH_TEAM, data: {team: "team"}
 * type: RESET, data: {}
 */
class RequestType {
  static const String GET_BOARD = "GET_BOARD",
      PICK = "PICK",
      SWITCH_TEAM = "SWITCH_TEAM",
      RESET = "RESET";
}

class Team {
  static const String RED = "RED",
      BLUE = "BLUE",
      NEUTRAL = "NEUTRAL",
      DEATH = "DEATH";
}
